/* aylet 0.2, a .AY music file player.
 * Copyright (C) 2001 Russell Marks and Ian Collier. See main.c for licence.
 *
 * drv_obsd.c - (Rough) native audio driver for OpenBSD (by Chris Cox).
 */

#ifdef DRIVER_OPENBSD

#include <sys/types.h>
#include <sys/ioctl.h>
#include <string.h>
#include <sys/audioio.h>
#include <unistd.h>
#include <fcntl.h>
#include "sound.h"

#include "driver.h"


int driver_init (int *freqptr, int *stereoptr)
{
	audio_info_t ainfo;

	if (play_to_stdout)
	{
		soundfd = 1;
		return 1;
	}

	if ((soundfd = open ("/dev/sound", O_WRONLY, 0)) < 0)
		return 0;

	AUDIO_INITINFO (&ainfo);

	/* TODO: hackish. */
	ainfo.play.encoding = AUDIO_ENCODING_SLINEAR;
	ainfo.play.channels = (*stereoptr) ? 2 : 1;
	ainfo.play.precision = 16;
	ainfo.play.sample_rate = (*freqptr); 

	if ((ioctl (soundfd, AUDIO_SETINFO, &ainfo)) < 0)
	{
		sixteenbit = 0;
		return 0;
	}
	else
		sixteenbit = 1;

	return 1;
}

void driver_end (void)
{
    if (soundfd > 1)
	close (soundfd);
}


void driver_frame(unsigned char *data, int len)
{
    static unsigned char buf16[8192];
    int ret=0,ofs=0;

    if (sixteenbit)
    {
	unsigned char *src,*dst;
	int f;

	src=data; dst=buf16;
	for(f=0;f<len;f++)
	{
	    *dst++=128;
	    *dst++=*src++-128;
	}

	data=buf16;
	len<<=1;
    }

    while(len)
    {
	ret=write(soundfd,data+ofs,len);
	if(ret>0)
	    ofs+=ret,len-=ret;
    }
}

#endif	/* DRIVER_OPENBSD */
